' This class is "generated" and will be overwritten.
' Your customizations should be made in AbsentRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="AbsentRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="AbsentTable"></see> class.
''' </remarks>
''' <seealso cref="AbsentTable"></seealso>
''' <seealso cref="AbsentRecord"></seealso>

<Serializable()> Public Class BaseAbsentRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As AbsentTable = AbsentTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub AbsentRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim AbsentRec As AbsentRecord = CType(sender,AbsentRecord)
        Validate_Inserting()
        If Not AbsentRec Is Nothing AndAlso Not AbsentRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub AbsentRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim AbsentRec As AbsentRecord = CType(sender,AbsentRecord)
        Validate_Updating()
        If Not AbsentRec Is Nothing AndAlso Not AbsentRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub AbsentRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim AbsentRec As AbsentRecord = CType(sender,AbsentRecord)
        If Not AbsentRec Is Nothing AndAlso Not AbsentRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Absent_.AbsentId field.
	''' </summary>
	Public Function GetAbsentIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.AbsentIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Absent_.AbsentId field.
	''' </summary>
	Public Function GetAbsentIdFieldValue() As Byte
		Return CType(Me.GetValue(TableUtils.AbsentIdColumn).ToByte(), Byte)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Absent_.AbsentId field.
	''' </summary>
	Public Sub SetAbsentIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.AbsentIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Absent_.AbsentId field.
	''' </summary>
	Public Sub SetAbsentIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.AbsentIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Absent_.AbsentId field.
	''' </summary>
	Public Sub SetAbsentIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.AbsentIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Absent_.AbsentId field.
	''' </summary>
	Public Sub SetAbsentIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.AbsentIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Absent_.AbsentId field.
	''' </summary>
	Public Sub SetAbsentIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.AbsentIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Absent_.Absent field.
	''' </summary>
	Public Function GetAbsentValue() As ColumnValue
		Return Me.GetValue(TableUtils.AbsentColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Absent_.Absent field.
	''' </summary>
	Public Function GetAbsentFieldValue() As String
		Return CType(Me.GetValue(TableUtils.AbsentColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Absent_.Absent field.
	''' </summary>
	Public Sub SetAbsentFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.AbsentColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Absent_.Absent field.
	''' </summary>
	Public Sub SetAbsentFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.AbsentColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Absent_.AbsentId field.
	''' </summary>
	Public Property AbsentId() As Byte
		Get 
			Return CType(Me.GetValue(TableUtils.AbsentIdColumn).ToByte(), Byte)
		End Get
		Set (ByVal val As Byte) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.AbsentIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property AbsentIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.AbsentIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property AbsentIdDefault() As String
        Get
            Return TableUtils.AbsentIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Absent_.Absent field.
	''' </summary>
	Public Property Absent() As String
		Get 
			Return CType(Me.GetValue(TableUtils.AbsentColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.AbsentColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property AbsentSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.AbsentColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property AbsentDefault() As String
        Get
            Return TableUtils.AbsentColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
